; ==================================================
.MACRO SPini
    ldi r16,low(ramend)
    out spl,r16
    ldi r16,high(ramend)
    out sph,r16
.ENDM
;  (00)============================================
.MACRO Ram_00
	ldi zl,low(sram_start) 
            	ldi zh,high(sram_start)
Flush:      	clr r25
            	st  z+,r25
            	cpi zh,high(ramend+1)
            	brne    Flush 
            
            	cpi zl,low(ramend+1)
            	brne    Flush
            
            	clr zl
            	clr zh
            	; 
            	ldi zl,30
            	clr zh
            	dec zl
            	st z,zh
            	brne pc-2
.ENDM
;  (FF)====================================================================
.MACRO Ram_FF
RAM_Flush:  ldi zl,low(sram_start) 
            ldi zh,high(sram_start)
Flush:      ser r25
            st  z+,r25
            cpi zh,high(ramend+1)
            brne    Flush 
            
            cpi zl,low(ramend+1)
            brne    Flush
            
            clr zl
            clr zh
            ; 
            ldi zl,30
            clr zh
            dec zl
            st z,zh
            brne pc-2
.ENDM

;    Z====================================================
.macro AdrZ
	ldi zl,low(@0*2)	;@0 -  
	ldi zh,high(@0*2)
.endm
;    Y=====================================================
.macro AdrY
	ldi yl,low(@0*2)
	ldi yh,high(@0*2);@ -  
.endm
;    X=====================================================
.macro AdrX
	ldi xl,low(@0*2)
	ldi xh,high(@0*2);@ -  
.endm


;   (  )================================
.macro Division_IB 	;    r25,r26,r27,28
	push r25	;16
	push r26	;17
	push r27	;18
	push r28	;7
	mov r25,@0	;@0 - 
	ldi r26,@1	;@1 - 
	cpi r26,0
	breq pc+7
	clr r27
	mov r28,r27
	inc r27
	sub r25,r26
	brcc pc-3
	mov @2,r28	;@2 - 		
	pop r28
	pop r27
	pop r26
	pop r25 

.endmacro
;   (  )
.macro Division_RB ;    1 Byte................................................
	 	;(    r13,r14,r15,)
	push r25	;13
	push r26	;14
	push r27	;15
	clr r27	
	mov r25,@0	;@0 -  ()
	mov r26,@1	;@1 -  ()
loop:	sub r25,r26	;@2 -  ()
	inc r27
	brcs pc+2
	rjmp loop
	dec r27
	mov @2,r27
	pop r27
	pop r26
	pop r25
.endm
;     ================================================================

.macro multiplay
	push r25	;16
	push r26	;17
	push r27	;18
	
	mov r25,@0	;@0- 
	ldi r26,@1	;@1- 
		;@2-
	clr r27
	add r27,r25
	dec r26
	brne PC-2
	mov @2,r27

	pop r27
	pop r26
	pop r25	
.endm
